#include <iostream>

class Fiinta {
public:
    /// Functie virtuala
    virtual void SeHraneste() const
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Om : public Fiinta {
public:

    /// Redefinire (overriding)
    void SeHraneste() const
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Animal : public Fiinta {
public:
    void SeHraneste() const
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Barbat : public Om {
public:
    void SeHraneste() const
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Femeie : public Om {
public:
    void SeHraneste() const
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Caine : public Animal {
public:
    void SeHraneste() const
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
};
/// LEGARE STATICA (Static Binding, Early Binding)
/// LEGARE (binding) -  asociere unui apel de functie cu codul care se va executa runtime
/// Daca decizia se ia compile-time => Static Binding
/// Decizia se ia in functie de TIPUL pointerului


int main()
{
    char c;
    Fiinta* pf = nullptr;

    do
    {

        std::cout << "I - Fiinta\n";
        std::cout << "O - Om\n";
        std::cout << "A - Animal\n";
        std::cout << "B - Barbat\n";
        std::cout << "F - Femeie\n";
        std::cout << "C - Caine\n";
        std::cout << "X - Iesire\n";

        std::cin >> c;

        switch (c)
        {
            case 'I' :
            case 'i' : pf = new Fiinta; break;
            case 'O' :
            case 'o' : pf = new Om; break;
            case 'B' :
            case 'b' : pf = new Barbat; break;
            case 'F' :
            case 'f' : pf = new Femeie; break;
            case 'A' :
            case 'a' : pf = new Animal; break;
            case 'C' :
            case 'c' : pf = new Caine; break;

            default : std::cout << "Bye!";
        }

        if (pf != nullptr)
        {
            /// SeHraneste() - Functie Polimorfica
            pf->SeHraneste();

            delete pf;
            pf = nullptr;

        }
    } while (c != 'X' && c != 'x');
}
